#pragma once
#include <vector>
#include <utility>
#include <string>

struct Pair {
  size_t j = 0;
  size_t i = 0;
};

typedef std::vector<Pair> PairList;
typedef std::vector<int> MatrixRow;
typedef std::vector<MatrixRow> Matrix;

void dump_map(const std::string &msg, Matrix &map);
void add_neighbors(Matrix &closed, size_t j, size_t i);

Matrix dijkstra_map(Matrix &input_map, Matrix &walls_map, int limit=0);
